// T-Code Random Stroker v0.4
// TempestVR 15-5-20
// Please copy, share, learn, innovate, give attribution.
// This plugin animates the hips of a female with a series of fun randomised motions.
// It also then outputs a synced stream of data to the Serial Port that can be used 
// to drive a generic device (T-code)
//
// 15-3-20, v0.4 - Rough WIP. Random stroker, T-Code output, animated pelvis. Limited control interface.

// Import libraries
using UnityEngine;
using System.Collections.Generic;
using System;
using System.IO.Ports; 
using System.Net.Sockets;
using System.Net;

// The magic starts here
namespace SerialCtrl {
    public class RandomStroker : MVRScript {
		
        // Name of plugin
        public static string pluginName = "Random Stroker";
		
		// Serial Variables
        protected JSONStorableStringChooser portChooser;
#region UDP
		private readonly string _defaultIPAddress = "192.168.0.150";
		private readonly string _defaultPort = "8000";
		private UdpClient _udpClient;
        protected JSONStorableString networkAddress;
        //protected JSONStorableString networkPort;
        //protected JSONStorableString networkStatus;
		private bool _isConnected = false;
		private bool _isConnecting = false;
        protected UIDynamicButton connectUDPButton;
        protected UIDynamicButton stopUDPButton;
#endregion
        private string[] portNames;
        private string portSelected = "None";
		private int baudRate;
		private string pulseString = "";
        protected UIDynamicButton startButton;
        protected UIDynamicButton stopButton;
        protected JSONStorableString serialReport;
        protected UIDynamicTextField serialOutWindow;
		
		// TCode Variables
		protected JSONStorableFloat OutMaxX;
        protected JSONStorableFloat OutMinX;
        protected JSONStorableFloat OutMaxRY;
        protected JSONStorableFloat AdjustRY;
        protected JSONStorableFloat OutMaxRZ;
        protected JSONStorableFloat AdjustRZ;
		protected JSONStorableFloat OutMaxV0;
        protected JSONStorableBool InvertX;
        protected JSONStorableBool InvertRY;
        protected JSONStorableBool InvertRZ;
        protected JSONStorableBool OverrideBoolX;
        protected JSONStorableBool OverrideBoolRY;
        protected JSONStorableBool OverrideBoolRZ;
		protected JSONStorableBool OverrideBoolV0;
        protected JSONStorableFloat OverrideX;
        protected JSONStorableFloat OverrideRY;
        protected JSONStorableFloat OverrideRZ;
		protected JSONStorableFloat OverrideV0;

        // Overrides for female update positining
        protected JSONStorableBool bOverrideFY;
        protected JSONStorableFloat OverrideFY;
		protected JSONStorableBool bOverrideFZ;
        protected JSONStorableFloat OverrideFZ;
		
		protected JSONStorableBool bOverrideMalePenis;
		protected JSONStorableFloat OverrideMalePenisX;
		protected JSONStorableFloat OverrideMalePenisY;
		protected JSONStorableFloat OverrideMalePenisZ;

		// Output command variables
		private float xCmd;
		private float ryCmd;
		private float rzCmd;
		private float v0Cmd;
		
		// Stroker UI variables
		protected JSONStorableFloat levelControl;
		protected JSONStorableFloat levelStep;
		protected JSONStorableFloat timerDisplay;
		protected JSONStorableFloat overrideMode;
		protected JSONStorableString strokerReport;
        protected UIDynamicTextField strokerWindow;
		protected JSONStorableBool vibeModes;
		protected JSONStorableBool levelModes;
		protected JSONStorableBool overrideSetMode;
		protected JSONStorableBool shortStrokesModes;
		protected JSONStorableBool longStrokesModes;
		protected JSONStorableBool lowTeaseModes;
		protected JSONStorableBool highTeaseModes;
		
		// Random stroker variables
		// Timer
		private float step;             // Time step [sec]
		private float iMin = 0.5f;      // Interval Minimum [sec]
		private float iMax = 6f;        // Interval Maximum [sec]
		private float orgasmTimer = 4f; 	// Number of cycles at maximum intensity before reset
		private float orgasmCount;
		private float increasingIntensity; // For counting whether the intensity is increasing to maintain momentum
		private float increasingIntensityLimit = 5;
		private float decreasingIntensity; // For counting whether the intensity is decreasing to maintain momentum
		private float decreasingIntensityLimit = 3;

		// Starting positions
		private float level = 0f;       // Start at minimum intensity
		private float levelIncrement = 0f;	// Start step at a minimum intensity
		private float timer = 0f;       // Interval countdown timer [sec] (time to reach new key point)
		private float xUp = 1f;         // Current stroke top [0.0 - 1.0]
		private float xDown = 0.8f;     // Current stroke bottom [0.0 - 1.0]
		private float xAngle = 0f;      // Current angular position of stroke [radians]
		private float grind = 0f;       // Current grind factor
		private float tilt = 0.0f;      // Current off axis tilt of MAxSR [0.0 - 1.0]
		private float tiltAngle = 0f;   // Current direction of tilt of MAxSR [radians]
		private float vibe1 = 0f;       // Current vibration level - channel 1 [0.0 - 1.0]
		private int mode = 3;           // Current movement mode [1,2,3,etc]
		
		// Rates
		private float xW = 0f;          // Current angular speed of stoke [radians/sec]
		private float tiltW = 0f;       // Current angular speed of tilt direction [radians/sec]

		// Change rates
		private float levelV = 0f;      // Rate of increase of intensity
		private float xDUp = 0f;        // Rate of change of current stroke top
		private float xDDown = 0f;      // Rate of change of current stroke bottom
		private float xDW = 0f;         // Rate of change of angular stroke speed [radians/sec^2]
		private float grindV = 0f;      // Rate of change of grind
		private float tiltV = 0f;       // Rate of change of tilt
		private float tiltDW = 0f;      // Rate of change of speed of tilt direction [radians/sec^2]
		private float vibe1V = 0f;      // Rate of change of vibration level

		
		// Atom Manipulation Variables
		// Male variables
		protected JSONStorableStringChooser maleChooser;
		protected JSONStorableString maleString;
        private Atom maleObject;
		private FreeControllerV3 malePenisTip;
        private FreeControllerV3 malePenisBase;
        private FreeControllerV3 maleHead;
        private Vector3 malePenisTipX;
        private Vector3 malePenisBaseX;
		private Quaternion malePenisRef;
		private float malePenisLength;
        private Vector3 malePenisRefX;
        private Vector3 malePenisRefY;
        private Vector3 malePenisRefZ;
        private Vector3 maleHeadX;

		// Female variables
		protected JSONStorableStringChooser femaleChooser;
        protected JSONStorableString femaleString;
        private Atom femaleObject; 
        private FreeControllerV3 femaleHead;
        private FreeControllerV3 femalePelvis;
		private FreeControllerV3 femaleThighLeft;
		private FreeControllerV3 femaleThighRight;
	
	
		
		// Serial Stuff
        SerialPort serial;
		
		// Function to initiate plugin
        public override void Init() {
			
			pluginLabelJSON.val = "Random Stroker";
			
			// Left Column of UI - Serial stuff
			
			// Select COM Port
            portNames = System.IO.Ports.SerialPort.GetPortNames();
            List<string> comPorts = new List<string>(portNames);
			portChooser = new JSONStorableStringChooser("COM Port Chooser", comPorts, "None", "Select COM port", PortChooserCallback);
			UIDynamicPopup portChooserPopup = CreatePopup(portChooser, false);
			portChooserPopup.labelWidth = 300f;
			
			// Set Baud Rate
			baudRate = 115200;
			
			// Serial buttons
			startButton = CreateButton("Start Serial", false);
			if (startButton != null) {
				startButton.button.onClick.AddListener(StartButtonCallback);
			}
			stopButton = CreateButton("Stop Serial", false);
			if (stopButton != null) {
				stopButton.button.onClick.AddListener(StopButtonCallback);
			}
			
			// Window to show what's being sent over serial
			serialReport = new JSONStorableString("Serial Output", "");
			serialOutWindow = CreateTextField(serialReport, false);
#region UDP
			networkAddress = new JSONStorableString("Network Info", _defaultIPAddress)
			{
				interactable = true
			};
			
			setNetworkStatus();
			UIDynamicTextField networkAddressTextFeild = CreateTextField(networkAddress);
			networkAddressTextFeild.enabled = true;
			networkAddressTextFeild.UItext.enabled = true;
			//networkPort = new JSONStorableString("Network port", _defaultPort);
			//UIDynamicTextField networkPortTextField = CreateTextField(networkPort);
			//networkPortTextField.enabled = true;
			//networkPortTextField.UItext.enabled = true;
			//networkStatus = new JSONStorableString("Network status", "Not connected");
			//UIDynamicTextField networkStatusFeild = CreateTextField(networkStatus);
			// UDP buttons
			connectUDPButton = CreateButton("Connect UDP", false);
			connectUDPButton.button.onClick.AddListener(ConnectUDPButtonCallback);
			stopUDPButton = CreateButton("Stop UDP", false);
			stopUDPButton.button.onClick.AddListener(StopUDPButtonCallback);
#endregion
			// Axis limits
			// X
			OutMaxX = new JSONStorableFloat("Max Stroke Output", 0.90f, 0.5f, 1f, true, true);
			RegisterFloat(OutMaxX);
			CreateSlider(OutMaxX, false);
			OutMinX = new JSONStorableFloat("Min Stroke Output", 0.5f, 0f, 0.5f, true, true);
			RegisterFloat(OutMinX);
			CreateSlider(OutMinX, false);
			// RY
			OutMaxRY = new JSONStorableFloat("Max Roll Output (+/-)", 0.5f, 0f, 0.5f, true, true);
			CreateSlider(OutMaxRY, false);
			AdjustRY = new JSONStorableFloat("Adjust Roll", 0f, -0.25f, 0.25f, true, true);
			RegisterFloat(AdjustRY);
			CreateSlider(AdjustRY, false);
			// RZ
			OutMaxRZ = new JSONStorableFloat("Max Pitch Output (+/-)", 0.5f, 0f, 0.5f, true, true);
			RegisterFloat(OutMaxRZ);
			CreateSlider(OutMaxRZ, false);
			AdjustRZ = new JSONStorableFloat("Adjust Pitch", 0f, -0.25f, 0.25f, true, true);
			RegisterFloat(AdjustRZ);
			CreateSlider(AdjustRZ, false);
			// V0
			OutMaxV0 = new JSONStorableFloat("Max Vib Output", 0.5f, 0f, 1f, true, true);
			RegisterFloat(OutMaxV0);
			CreateSlider(OutMaxV0, false);
			
			// Axis inverters
			InvertX = new JSONStorableBool("Invert Stroke", false);
			CreateToggle(InvertX, false);
			InvertRY = new JSONStorableBool("Invert Roll", false);
			CreateToggle(InvertRY, false);
			InvertRZ = new JSONStorableBool("Invert Pitch", false);
			CreateToggle(InvertRZ, false);
			
			// Axis manual overrides
			// X
			OverrideBoolX = new JSONStorableBool("Override Stroke", false);
			CreateToggle(OverrideBoolX, false);
			OverrideX = new JSONStorableFloat("Override Stroke Position", 0.5f, 0f, 1f, true, true);
			RegisterFloat(OverrideX);
			CreateSlider(OverrideX, false);
			// RY
			OverrideBoolRY = new JSONStorableBool("Override Roll", false);
			CreateToggle(OverrideBoolRY, false);
			OverrideRY = new JSONStorableFloat("Override Roll", 0.5f, 0f, 1f, true, true);
			RegisterFloat(OverrideRY);
			CreateSlider(OverrideRY, false);
			// RZ
			OverrideBoolRZ = new JSONStorableBool("Override Pitch", false);
			CreateToggle(OverrideBoolRZ, false);
			OverrideRZ = new JSONStorableFloat("Override Pitch", 0.5f, 0f, 1f, true, true);
			CreateSlider(OverrideRZ, false);  
			// V0
			OverrideBoolV0 = new JSONStorableBool("Override Vibration", false);
			CreateToggle(OverrideBoolV0, false);
			OverrideV0 = new JSONStorableFloat("Override Vibration", 0.5f, 0f, 1f, true, true);
			CreateSlider(OverrideV0, false);  


            // Depth Input Override - this kind of controls the angle that the stroke is performed
			bOverrideFY = new JSONStorableBool("Override Female Depth Offset", true);
			CreateToggle(bOverrideFY, false);
			OverrideFY = new JSONStorableFloat("Override Female Depth Offset", 0.1f, -0.2f, 0.3f, true, true);
			RegisterFloat(OverrideFY);
			CreateSlider(OverrideFY, false);  

			// Vertical Override - shouldn't really ever be used
			bOverrideFZ = new JSONStorableBool("Override Female Vertical Offset", false);
			CreateToggle(bOverrideFZ, false);
			OverrideFZ = new JSONStorableFloat("Override Female Vertical Offset", -0.075f, -0.3f, 0.3f, true, true);
			CreateSlider(OverrideFZ, false);  


			// Male Penis Transform Override for Female Rotation
			bOverrideMalePenis = new JSONStorableBool("Override Male Penis References", false);
			CreateToggle(bOverrideMalePenis, false);

			OverrideMalePenisX = new JSONStorableFloat("Override Female Yaw Offset", 1.0f, -1.5f, 5f, true, true);
			CreateSlider(OverrideMalePenisX, false);  
			OverrideMalePenisY = new JSONStorableFloat("Override Female Vertical Offset", 1.5f, -1.5f, 5f, true, true);
			CreateSlider(OverrideMalePenisY, false);  
			OverrideMalePenisZ = new JSONStorableFloat("Override Female Pitch Offset", 1.5f, -7f, 10f, true, true);
			CreateSlider(OverrideMalePenisZ, false); 

			
			
			// Right Column of UI 
			
			// Make a list of
			Atom currentAtom;
			List<string> targetChoices = new List<string>();
			foreach (string atomUID in SuperController.singleton.GetAtomUIDs()) {
				currentAtom = SuperController.singleton.GetAtomByUid(atomUID);
				if (atomUID != null && currentAtom.type == "Person") {
					targetChoices.Add(atomUID);
				}
			}
			
			// Set male character nodes
			// Use default male character, or else first on list
			maleString = new JSONStorableString("Male Person","Person#2");
            RegisterString(maleString);
            if (SuperController.singleton.GetAtomByUid(maleString.val) == null) maleString.val = targetChoices[0];
			// Set nodes
			maleObject = SuperController.singleton.GetAtomByUid(maleString.val);
            malePenisTip = maleObject.GetStorableByID("penisTipControl") as FreeControllerV3;
		//	malePenisTip.currentPositionState = FreeControllerV3.PositionState.On;
		//	malePenisTip.currentRotationState = FreeControllerV3.RotationState.On;
            malePenisBase = maleObject.GetStorableByID("penisBaseControl") as FreeControllerV3;
			malePenisBase.currentPositionState = FreeControllerV3.PositionState.On;
		//	malePenisBase.currentRotationState = FreeControllerV3.RotationState.On;
			maleHead = maleObject.GetStorableByID("headControl") as FreeControllerV3;
			// Chooser menu
			maleChooser = new JSONStorableStringChooser("Reference Chooser", targetChoices, maleString.val, "Select Male",MaleChooserCallback);
            UIDynamicPopup maleChooserPopup = CreatePopup(maleChooser, true);
			maleChooserPopup.labelWidth = 300f;

			// Set female character nodes
			// Use default female character, or else first on list
            femaleString = new JSONStorableString("Female Person","Person");
            RegisterString(femaleString);
            if (SuperController.singleton.GetAtomByUid(femaleString.val) == null) femaleString.val = targetChoices[0];
			// Set nodes
            femaleObject = SuperController.singleton.GetAtomByUid(femaleString.val);
            femalePelvis = femaleObject.GetStorableByID("pelvisControl") as FreeControllerV3;
		//	femalePelvis.currentPositionState = FreeControllerV3.PositionState.On;
		//	femalePelvis.currentRotationState = FreeControllerV3.RotationState.On;
			femaleThighLeft = femaleObject.GetStorableByID("lThighControl") as FreeControllerV3;
		//	femaleThighLeft.currentPositionState = FreeControllerV3.PositionState.On;
			femaleThighRight = femaleObject.GetStorableByID("rThighControl") as FreeControllerV3;
		//	femaleThighRight.currentPositionState = FreeControllerV3.PositionState.On;
            femaleHead = femaleObject.GetStorableByID("headControl") as FreeControllerV3;
		//	femaleHead.currentPositionState = FreeControllerV3.PositionState.On;
		//	femaleHead.currentRotationState = FreeControllerV3.RotationState.On;
			// Chooser menu
			femaleChooser = new JSONStorableStringChooser("Target Chooser", targetChoices, femaleString.val, "Select Female", FemaleChooserCallback);
            UIDynamicPopup femaleChooserPopup = CreatePopup(femaleChooser, true);
			femaleChooserPopup.labelWidth = 300f;

			
		    // Window to show target position
            strokerReport = new JSONStorableString("Target Position", "");
            strokerWindow = CreateTextField(strokerReport, true);

			levelModes = new JSONStorableBool("Randomize Intensity Level", false);
			CreateToggle(levelModes, true);
			
			levelControl = new JSONStorableFloat("Intensity Level", 0.25f, 0f, 1f, true, true);
			RegisterFloat(levelControl);
			CreateSlider(levelControl, true);

			levelStep = new JSONStorableFloat("Intensity Step", 0.07f, 0f, 1f, true, true);
			RegisterFloat(levelStep);
			CreateSlider(levelStep, true);

			timerDisplay = new JSONStorableFloat("timerDisplay", 5f, 0f, 10f, true, true);
			RegisterFloat(timerDisplay);
			CreateSlider(timerDisplay, true);
			
			vibeModes = new JSONStorableBool("Include Vibration Modes", false);
			CreateToggle(vibeModes, true);

			overrideSetMode = new JSONStorableBool("Override Mode", true);
			CreateToggle(overrideSetMode, true);
			overrideMode = new JSONStorableFloat("Set Mode", 7f, 0f, 11f, true, true);
			RegisterFloat(overrideMode);
			CreateSlider(overrideMode, true); 

			/*

			shortStrokesModes = new JSONStorableBool("Include Short Strokes", true);
			CreateToggle(shortStrokesModes, true);
			
			longStrokesModes = new JSONStorableBool("Include long Strokes", true);
			CreateToggle(longStrokesModes, true);

			lowTeaseModes = new JSONStorableBool("Include Low Tease", true);
			CreateToggle(lowTeaseModes, true);

			highTeaseModes = new JSONStorableBool("Include High Tease", true);
			CreateToggle(highTeaseModes, true);

			*/
        }
		
#region UDP
		private void SendClientHandshake(string address, string port)
        {
            try
            {
            	//SuperController.LogMessage($"Enter handshake: {address}:{port}");
                if (!_isConnected)
			    {
					setNetworkStatus(true);
            		//SuperController.LogMessage($"Connecting");
					_isConnecting = true;
					IPEndPoint tcodeIPEndPoint = CreateIPEndPoint(address + ":" + port);
					_udpClient = new UdpClient();
					_udpClient.Connect(tcodeIPEndPoint);
					var password = System.Text.Encoding.ASCII.GetBytes("D1\n");
					//Log.Debug(DateTime.Now + " Sending udp connection handshake");
					_udpClient.Send(password, password.Length);
					_udpClient.BeginReceive(ReceiveCallback, new UdpState() {udp = _udpClient, ip = tcodeIPEndPoint});
                }
			}
            catch (Exception e)
            {
                SuperController.LogError("UDP Exception: " + e);
            }
        }

		private class UdpState {
			public UdpClient udp;
			public IPEndPoint ip;
		}

		private void ReceiveCallback(IAsyncResult ar)
		{
            try
            {
				UdpClient u = ((UdpState)(ar.AsyncState)).udp;
				IPEndPoint e = ((UdpState)(ar.AsyncState)).ip;

				byte[] receiveBytes = u.EndReceive(ar, ref e);
				string receiveString = System.Text.Encoding.ASCII.GetString(receiveBytes);

            	SuperController.LogMessage(receiveString);
				if (receiveString.Contains("TCode"))
				{
					_isConnected = true;
				}
				_isConnecting = false;
				setNetworkStatus();
			}
            catch (Exception e)
            {
                SuperController.LogError("UDP callback Exception: " + e);
            }
		}
		private void setNetworkStatus(bool connecting = false) {
            networkAddress.val = _defaultIPAddress + ":" + _defaultPort + "\n" + (connecting ? "Connecting..." : (_isConnected ? "Connected" : "Not connected"));
		}
		// Handles IPv4 and IPv6 notation.
		public static IPEndPoint CreateIPEndPoint(string endPoint)
		{
			string[] ep = endPoint.Split(':');
			if (ep.Length < 2) throw new FormatException("Invalid endpoint format");
			IPAddress ip;
			if (ep.Length > 2)
			{
				if (!IPAddress.TryParse(string.Join(":", ep, 0, ep.Length - 1), out ip))
				{
					throw new FormatException("Invalid ip-adress");
				}
			}
			else
			{
				if (!IPAddress.TryParse(ep[0], out ip))
				{
					throw new FormatException("Invalid ip-adress");
				}
			}
			int port;
			if (!int.TryParse(ep[ep.Length - 1], System.Globalization.NumberStyles.None, System.Globalization.NumberFormatInfo.CurrentInfo, out port))
			{
				throw new FormatException("Invalid port");
			}
			return new IPEndPoint(ip, port);
		}

		private void sendTCodeUDP(string tcode) {
			var tcodeBytes = System.Text.Encoding.ASCII.GetBytes(tcode);
			_udpClient.Send(tcodeBytes, tcodeBytes.Length);
		}

        protected void ConnectUDPButtonCallback() {
			connectUDPButton.enabled = false;
			stopUDPButton.enabled = true;
            SuperController.LogMessage("UDP connecting: " + _defaultIPAddress + ":" + _defaultPort );
            SendClientHandshake(_defaultIPAddress, _defaultPort);
        }

        protected void StopUDPButtonCallback() {
			connectUDPButton.enabled = true;
			stopUDPButton.enabled = false;
			_isConnecting = false;
			_isConnected = false;
			if(_udpClient != null)
				_udpClient.Close();
            SuperController.LogMessage("UDP connection stopped");
        }
#endregion		
		
		// Update is called with each rendered frame by Unity
        void Update() {
			
			// Do the random stroker stuff
			
			// If interval countdown timer expires, reset
			if (timer <= 0) {
				
				// Mode change randomiser
				//Trusty Edit - removed vibration - added additional Range in order to weight the different options
				// already weighted such that there is a 30% chance to continue repeating the current action
				if (UnityEngine.Random.Range(0f, 1f) < 0.3) {
					int modeMax;
					
					modeMax = 10;
					
					mode = UnityEngine.Random.Range(0,modeMax);
				}
				
				
				// Set new interval countdown timer
				// Trust Edit - timers are based on the type of randomization so determined within SetStrokeParams
				
				
				// Stroke randomiser variables
				SetStrokeParams(mode);
				
			}

			// Set timestep
			step = Time.deltaTime;
			timer -= step;

			// Display the timer in the VAM plugin as a slider - comment out for slight performance improvement
			// timerDisplay.val = timer;

			// Update operating values for this timestep
			level += levelV * step;
			xUp += xDUp * step;
			xDown += xDDown * step;
			xW += xDW * step;
			grind += grindV * step;
			tiltW += tiltDW * step;
			tilt += tiltV * step;
			vibe1 += vibe1V * step;
			xAngle += xW * step;
			tiltAngle += tiltW * step;

			// Calculate channel output values
			xCmd = (xUp + xDown)/2 + Mathf.Cos(xAngle)*(xUp - xDown)/2;
			ryCmd = 0.5f * tilt * Mathf.Sin(tiltAngle) + 0.5f;
			rzCmd = 0.5f * tilt * Mathf.Cos(tiltAngle) + 0.5f * grind * Mathf.Sin(xAngle)+ 0.5f;
			v0Cmd = vibe1;
			
			// Axis inverters
			if (InvertX.val) xCmd = 1f - xCmd;
			if (InvertRY.val) ryCmd = 1f - ryCmd;
			if (InvertRZ.val) rzCmd = 1f - rzCmd;
			
			// Manual overrides
			if (OverrideBoolX.val) xCmd = OverrideX.val;
			if (OverrideBoolRY.val) ryCmd = OverrideRY.val;
			if (OverrideBoolRZ.val) rzCmd = OverrideRZ.val;
			if (OverrideBoolV0.val) v0Cmd = OverrideV0.val;
			
			// Send data over serial
			if ((serial != null && serial.IsOpen) || _isConnected) {
				SendPulse();
			}
			
			// Do the animation stuff
            // Penis reference frame  -  UGLY. Need to fix this!
            malePenisRefZ = malePenisTip.transform.position - malePenisBase.transform.position;
            malePenisRefX = Vector3.Cross(malePenisRefZ,maleHead.transform.position-malePenisBase.transform.position);
            malePenisRefX = (malePenisRefZ.magnitude/malePenisRefX.magnitude)*malePenisRefX;
            malePenisRefY = Vector3.Cross(malePenisRefX,malePenisRefZ);
            malePenisRefY = (malePenisRefZ.magnitude/malePenisRefY.magnitude)*malePenisRefY;

			// New reference frame - Bette!
			malePenisRef = Quaternion.LookRotation((malePenisTip.transform.position - malePenisBase.transform.position),(maleHead.transform.position - malePenisBase.transform.position)); // This identifies the forward direction as the tilt of the penis?, and the upwards direction as the penis towards the head
			malePenisLength = (malePenisTip.transform.position - malePenisBase.transform.position).magnitude;

			// Need to fix this too!
			if (bOverrideMalePenis.val)
			{
				femalePelvis.transform.rotation = Quaternion.LookRotation(malePenisRefY+(OverrideMalePenisZ.val*(rzCmd-0.5f)*malePenisRefZ),malePenisRefZ-(OverrideMalePenisY.val*(rzCmd-0.5f)*malePenisRefY)-(OverrideMalePenisX.val*(ryCmd-0.5f)*malePenisRefX));
			} else
			{
				femalePelvis.transform.rotation = Quaternion.LookRotation(malePenisRefY+(1.5f*(rzCmd-0.5f)*malePenisRefZ),malePenisRefZ-(1.5f*(rzCmd-0.5f)*malePenisRefY)-(1f*(ryCmd-0.5f)*malePenisRefX));
			}
            
			// Animate the pelvis and thighs

            if (bOverrideFY.val)
            {
                femalePelvis.transform.position = malePenisTip.transform.position + malePenisRef* new Vector3(0f,OverrideFY.val*(1f-xCmd), -0.075f + 0.18f*xCmd) + femalePelvis.transform.rotation* new Vector3(0f,0.05f,-0.02f);
            } else if (bOverrideFZ.val)
            {
                 femalePelvis.transform.position = malePenisTip.transform.position + malePenisRef* new Vector3(0f, 0.1f*(1f-xCmd),OverrideFZ.val + 0.18f*xCmd) + femalePelvis.transform.rotation* new Vector3(0f,0.05f,-0.02f);
            } else if (bOverrideFZ.val && bOverrideFY.val)
            {
                 femalePelvis.transform.position = malePenisTip.transform.position + malePenisRef* new Vector3(0f,OverrideFY.val*(1f-xCmd),OverrideFZ.val + 0.18f*xCmd) + femalePelvis.transform.rotation* new Vector3(0f,0.05f,-0.02f);
            } else
            {  
                femalePelvis.transform.position = malePenisTip.transform.position + malePenisRef* new Vector3(0f,0.1f*(1f-xCmd),-0.075f + 0.18f*xCmd) + femalePelvis.transform.rotation* new Vector3(0f,0.05f,-0.02f); // Female Pelvis Position - MalePenisTip Position + malePenisRef + (Horizontal Input * movement speed * time.deltatime, vertical input * movement speed * time.deltatime, 0)
            //	femaleThighLeft.transform.position = femalePelvis.transform.position + femalePelvis.transform.rotation* new Vector3(-0.08f,-0.05f - 0.05f*xCmd,0f);
            //	femaleThighRight.transform.position = femalePelvis.transform.position + femalePelvis.transform.rotation* new Vector3(0.08f,-0.05f - 0.05f*xCmd,0f);
            }

			// Don't need this yet!
            //femaleHead.transform.position = malePenisBase.transform.position + 2f*malePenisRefZ + new Vector3(0f,0.6f,0f);
			
		}
		
		
		
		// Button callbacks
		protected void PortChooserCallback(string s) {
            portSelected = s;
        }
		protected void StartButtonCallback() {
			StartSerial();
			SuperController.LogMessage("Serial connection started: " + portSelected + ", baud " + baudRate.ToString() );
        }
		protected void StopButtonCallback() {
			StopSerial();
			SuperController.LogMessage("Serial connection stopped");
		}
		protected void MaleChooserCallback(string s) {
			// Set new male object and nodes
			maleString.val = s;
			maleObject = SuperController.singleton.GetAtomByUid(maleString.val);
            malePenisTip = maleObject.GetStorableByID("penisTipControl") as FreeControllerV3;
		//	malePenisTip.currentPositionState = FreeControllerV3.PositionState.On;
		//	malePenisTip.currentRotationState = FreeControllerV3.RotationState.On;
            malePenisBase = maleObject.GetStorableByID("penisBaseControl") as FreeControllerV3;
		//	malePenisBase.currentPositionState = FreeControllerV3.PositionState.On;
		//	malePenisBase.currentRotationState = FreeControllerV3.RotationState.On;
			maleHead = maleObject.GetStorableByID("headControl") as FreeControllerV3;
        }
 
        protected void FemaleChooserCallback(string s) {
			// Set new female object and nodes
			femaleString.val = s;
			
        }
		
		
		// Serial functions
		// Function to start serial
		void StartSerial() {
			if (portSelected != "None") {
				// Add extra characters for COM ports > 9
				if (portSelected.Substring(0,3) == "COM") {
					if (portSelected.Length != 4) {
						portSelected = "\\\\.\\" + portSelected;
					}
				}
				
				// Open the serial connection
				serial = new SerialPort(portSelected, baudRate);
				serial.Open();
				serial.ReadTimeout = 10;
			}
		}
		// Function to stop serial
        void StopSerial() {
			if(serial != null && serial.IsOpen) serial.Close();
		}
		// Function to send serial
        void SendPulse() {
			pulseString = TCode("L0",xCmd,OutMinX.val,OutMaxX.val);
			pulseString += " ";
			pulseString += TCode("R1",ryCmd,0.5f-OutMaxRY.val,0.5f+OutMaxRY.val);
			pulseString += " ";
			pulseString += TCode("R2",rzCmd,0.5f-OutMaxRZ.val,0.5f+OutMaxRZ.val);
			pulseString += " ";
			pulseString += TCode("V0",v0Cmd,0f,OutMaxV0.val);
			pulseString += "\n";
			serialReport.val = " T-code:\n" + pulseString;
			if(_isConnected) {
				sendTCodeUDP(pulseString);
			} else if (serial != null && serial.IsOpen) {
				serial.WriteLine(pulseString);
			}
		}
		
		
		// TCode function
        string TCode(string channel, float input, float min, float max) {
            input = min + input*(max-min);
            input = input*1000;
            string output;
            if (input >= 999f) {
                output = channel + "999";
            } else if (input >= 1f) {
                output = channel + input.ToString("000");
            } else {
                output = channel + "000";
            }
            return output;
        }
		
		// This function sets the new stroke parameters
		void SetStrokeParams(int setMode) {

			/* 
			if (levelModes.val == true){
				levelIncrement = levelStep.val;
				level += UnityEngine.Random.Range(-levelIncrement,levelIncrement);
				levelControl.val = level;
			} else{
				level = levelControl.val;
			}
			*/

			//ToDo - orgasm timer (when level is at 1 for long enough (and in Random) then will reset to 0))
			// Also make it so that the step increment is weighted up/down - when going up it stays going up
			// when going down it stays going down - maybe a multiplier on the range based on a counter or something?
			// shouldn't be too hard to implement
			if (levelModes.val == true){

				if (level >= 0.99f) {
					// if at 100 intensity, stay there for X iterations for orgasm then reset to 0.
					if (orgasmCount >= orgasmTimer){
						orgasmCount = 0.0f;
						level = 0.0f;
						levelControl.val = level;

					}

					setMode = 0; // sets to the highest intensity version of the long ride

					orgasmCount += 1f;
				
				} else if (increasingIntensity <= increasingIntensityLimit){ 
					// when the intensity increases - this makes sure it continues to increase at least X iterations after
					increasingIntensity += 1f;
					levelIncrement = levelStep.val;
					level += UnityEngine.Random.Range(0.0f,levelIncrement);
					levelControl.val = level;

				} else if (decreasingIntensity <= decreasingIntensityLimit){
					// when the intensity decreases - this makes sure it continues to increase at least X iterations after
					decreasingIntensity += 1f;
					levelIncrement = levelStep.val;
					level += UnityEngine.Random.Range(-levelIncrement,0.0f);
					levelControl.val = level;

				} else {
					// the intensity is no longer in an increase/decrease cycle - so reset those and determine if increasing or decreasing
					increasingIntensity = 0f;
					decreasingIntensity = 0f;

					levelIncrement = levelStep.val;
					level += UnityEngine.Random.Range(-levelIncrement,levelIncrement);
					levelControl.val = level;

				}

			} else {
				level = levelControl.val;
			}
				
			// Temporary variables
			float stroke;
			float xDownNew;
			float xUpNew;
			float xWNew;
			float grindNew;
			float tiltNew;
			float tiltWNew;
			float vibe1New;
			
			// Trusty Edit
			// timer = UnityEngine.Random.Range(iMin, iMax);

			// TODO: lump these together so they are a little more readible, and also make them a bit more defined
			// Add in a 'low tease' that doesn't just circle but is a grinding motion.

			// allows overriding mode for debugging
			if (overrideSetMode.val == true)
			{
				setMode = (int)overrideMode.val;
			}

			
			// Movement modes are defined here	
			// Mode 11 is specifically for debugging and can't be triggered randomly
			if (setMode == 11) {
				// Debug Mode - original long ride
				timer = UnityEngine.Random.Range(2f, 10f);
				
				strokerReport.val = "Debug Mode";
				stroke = ScaledRandom(0.6f, 0.8f, 0.8f, 1f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 3f, 3f, 5f, level);
				grindNew = ScaledRandom(-0.9f, 0.9f, -0.9f, 0.9f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			} else if (setMode == 10) {
				// Low Tease
				timer = UnityEngine.Random.Range(2f, 5f);
				
				strokerReport.val = "Low Tease";
				stroke = ScaledRandom(0.1f, 0.2f, 0.2f, 0.3f, level);
				xDownNew = UnityEngine.Random.Range(0f, 0.1f);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(0.5f, 1f, 1.5f, 3f, level);
				grindNew = ScaledRandom(-0.1f, 0.1f, -0.1f, 0.1f, level);
				tiltNew = ScaledRandom(0.5f, 0.8f, 0.5f, 0.9f, level);
				tiltWNew = ScaledRandom(-2f, 2f, -6f, 6f, level);
				vibe1New = ScaledRandom(-0.2f, 0.2f, -0.1f, 0.4f, level);
			
			} else if (setMode == 9) {
				// Low Grind
				timer = UnityEngine.Random.Range(2f, 9f);
				
				strokerReport.val = "Low Grind";
				stroke = ScaledRandom(0.1f, 0.2f, 0.2f, 0.3f, level);
				xDownNew = UnityEngine.Random.Range(0f, 0.1f);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(6f, 10f, 8f, 12f, level);
				grindNew = ScaledRandom(-1.5f, 1.5f, -1.5f, 1.5f, level);
				tiltNew = ScaledRandom(-0.1f, 0.1f, -0.1f, 0.1f, level);
				tiltWNew = ScaledRandom(-2f, 2f, -6f, 6f, level);
				vibe1New = ScaledRandom(-0.2f, 0.2f, -0.1f, 0.4f, level);
			
			} else if (setMode == 8) {
				// Top Tease
				timer = UnityEngine.Random.Range(2f, 5f);
				
				strokerReport.val = "High Tease";
				stroke = ScaledRandom(0.1f, 0.2f, 0.2f, 0.3f, level);
				xDownNew = UnityEngine.Random.Range(0.7f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(0.5f, 1f, 1.5f, 3f, level);
				grindNew = ScaledRandom(-0.1f, 0.1f, -0.1f, 0.1f, level);
				tiltNew = ScaledRandom(0.5f, 0.8f, 0.5f, 0.9f, level);
				tiltWNew = ScaledRandom(-2f, 2f, -6f, 6f, level);
				vibe1New = ScaledRandom(-0.2f, 0.2f, -0.1f, 0.4f, level);

			} else if (setMode == 7) {
				// Long Strokes
				timer = UnityEngine.Random.Range(6f, 7f);
				
				strokerReport.val = "Long Strokes Fast Rock";
				stroke = ScaledRandom(0.4f, 0.4f, 0.9f, 0.9f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 2f, 7f, 7f, level);
				grindNew = ScaledRandom(1f, 1f, -1f, -1f, 1);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, 1);
				tiltWNew = ScaledRandom(0.5f, 0.5f, -1f, -1f, 1);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			} else if (setMode == 6) {
				// Long Strokes
				timer = UnityEngine.Random.Range(10f, 11f);
				
				strokerReport.val = "Long Strokes Faster Rock";
				stroke = ScaledRandom(0.4f, 0.4f, 0.9f, 0.9f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 2f, 7f, 7f, level);
				grindNew = ScaledRandom(-0.1f, 0.1f, -0.1f, 0.1f, level);
				tiltNew = ScaledRandom(0.5f, 0.8f, 0.5f, 0.9f, level);
				tiltWNew = ScaledRandom(-2f, 2f, -6f, 6f, level);			
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			}else if (setMode == 5) {	
				// Long Strokes
				timer = UnityEngine.Random.Range(18f, 20f);
				
				strokerReport.val = "Long Strokes Fastest Rock";
				stroke = ScaledRandom(0.4f, 0.4f, 0.9f, 0.9f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 2f, 7f, 7f, level);
				grindNew = ScaledRandom(1f, 1f, -1f, -1f, 1);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, 1);
				tiltWNew = ScaledRandom(0.5f, 0.5f, -1f, -1f, 1);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			}
			else if (setMode == 4) {	
				// Long Strokes
				timer = UnityEngine.Random.Range(2f, 10f);
				
				strokerReport.val = "Long Strokes 1";
				stroke = ScaledRandom(0.6f, 0.8f, 0.8f, 1f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 3f, 3f, 5f, level);
				grindNew = ScaledRandom(-0.9f, 0.9f, -0.8f, 0.8f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			} else if (setMode == 3) {
				// Long Strokes
				timer = UnityEngine.Random.Range(2f, 10f);
				
				strokerReport.val = "Long Strokes 2";
				stroke = ScaledRandom(0.6f, 0.8f, 0.8f, 1f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(3f, 6f, 5f, 10f, level);
				grindNew = ScaledRandom(-0.9f, 0.9f, -0.8f, 0.8f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
				
			} else if (setMode == 2) {
				// Long Strokes
				timer = UnityEngine.Random.Range(2f, 10f);
				
				strokerReport.val = "Long Strokes 3";
				stroke = ScaledRandom(0.6f, 1f, 0.8f, 1f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(0.5f, 2f, 3f, 5f, level);
				grindNew = ScaledRandom(-0.9f, 0.9f, -0.8f, 0.8f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);

			} else if (setMode == 1) {
				// Long Strokes
				timer = UnityEngine.Random.Range(2f, 10f);
				
				strokerReport.val = "Long Strokes 4";
				stroke = ScaledRandom(0.6f, 0.8f, 0.8f, 1f, level);
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke);
				xUpNew = xDownNew + stroke;
				xWNew = ScaledRandom(2f, 3f, 3f, 5f, level);
				grindNew = ScaledRandom(-0.9f, 0.9f, -0.8f, 0.8f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			} else {
				// Long Strokes
				timer = UnityEngine.Random.Range(2f, 10f); 					// timer for how long this state can last				
				
				
				strokerReport.val = "Long Strokes 5 / Orgasm";
				stroke = ScaledRandom(0.6f, 0.8f, 0.8f, 1f, level); 		//stroke length is between 0.6 and 1 -- produces an appropriate random value scaled by the intensity level
				xDownNew = UnityEngine.Random.Range(0f, 1f - stroke); 		//grabs a down value between 0 and (1 - previously determined stroke value)
				xUpNew = xDownNew + stroke; 								//goes back all the way up from the down value to the top of the stroke
				xWNew = ScaledRandom(5f, 10f, 10f, 18f, level); 			//This is the way to control the speed! rad/s of the stroke
				grindNew = ScaledRandom(-0.5f, 0.5f, -0.5f, 0.5f, level);
				tiltNew = ScaledRandom(0f, 0.1f, 0f, 0.2f, level);
				tiltWNew = ScaledRandom(-0.5f, 0.5f, -1f, 1f, level);
				vibe1New = ScaledRandom(0f, 0f, 0f, 0f, level);
			}
			
			// Trusty Edit - don't mess with these - these determine the step range for each movement
							// Why do the states repeat so much? it doesn't seem right.
			
			// Calculate ramp rates
			xDUp = (xUpNew-xUp)/timer;
			xDDown = (xDownNew-xDown)/timer;
			xDW = (xWNew-xW)/timer;
			grindV = (grindNew - grind) / timer;
			tiltV = (tiltNew-tilt)/timer;
			tiltDW = (tiltWNew-tiltW)/timer;
			//vibe1V = (vibe1New-vibe1)/timer;
		}
		
		// This function produces an appropriate random value to the intensity level
		float ScaledRandom(float lowMin, float lowMax, float highMin, float highMax, float level) {
			if (level < 0) level = 0;
			if (level > 1) level = 1;

			// Random function with interpolated inputs
			float output = UnityEngine.Random.Range(lowMin + (highMin-lowMin)*level,lowMax + (highMax-lowMax)*level);
			return output;
		}
		
		public void OnEnable()
		{
			try
			{
				SuperController.LogMessage($"{nameof(RandomStroker)} enabled");
			}
			catch (Exception e)
			{
				SuperController.LogError($"{nameof(RandomStroker)}.{nameof(OnEnable)}: {e}");
			}
		}

		public void OnDisable()
		{
			try
			{
				SuperController.LogMessage($"{nameof(RandomStroker)} disabled");
			}
			catch (Exception e)
			{
				SuperController.LogError($"{nameof(RandomStroker)}.{nameof(OnDisable)}: {e}");
			}
		}

		// Function to close plugin
        void OnDestroy() {
            StopSerial();
			StopUDPButtonCallback();
        }

		
    }
}